local doomsay = CreateFrame("Frame")
doomsay:RegisterEvent("GOSSIP_SHOW")

local sd = GetItemSpell(121745)	-- Sense Demons
local dd = GetItemSpell(9233)	-- Detect Demons
local ss = GetSpellInfo(188501)	-- Spectral Sight
local td = GetSpellInfo(19878)	-- Track Demons

local function coord(x)
	x = x*100
	local int = math.floor(math.floor(x * 10 + 0.5) / 10)
	local rem = math.floor(math.floor((x - int) * 10 + 0.5) / 10)
    rem = string.sub(tostring(rem),3)
    return int .. "." .. rem .. string.rep("0", 1 - string.len(rem))
end

doomsay:SetScript("OnEvent",
    function(...)
		if (UnitGUID("target"):sub(-17, -12)) == "112198" then
			if GetNumGossipOptions() > 1 then
				local posX, posY = GetPlayerMapPosition("player");
				local s = "DoomsayerSayer: Dread Infiltrator ready! Doomsayer in "..GetMinimapZoneText().." ("..coord(posX)..","..coord(posY)..")"
				SendChatMessage(s , "CHANNEL", nil, 1); 
				SendChatMessage("Dread Infiltrator ready here!");
			else
				local tracking = false
				if     UnitBuff("player", sd) then tracking = true
				elseif UnitBuff("player", dd) then tracking = true
				elseif UnitBuff("player", ss) then tracking = true
				else
					for i=1,GetNumTrackingTypes() do 
						local name,_,active = GetTrackingInfo(i);
						if name == td and active then tracking = true end
					end
				end
				if not tracking then print("DoomsayerSayer: You are not tracking Demons!") end
			end
		end
	end
);
